package cd.casic.server;

import cd.casic.ci.process.dto.resp.sast.TokenResp;
import cd.casic.ci.process.process.service.sast.SastService;
import cd.casic.ci.process.properties.SastProperties;
import cd.casic.framework.redis.core.RedisTemplateUtils;
import com.alibaba.fastjson.JSON;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.core.task.TaskExecutor;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.test.context.ActiveProfiles;

import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;

@SpringBootTest(classes = {OpsServerApplication.class})
@ActiveProfiles("local")
@Slf4j
public class SastTest {
    @Resource
    SastProperties sastProperties;
    @Resource
    SastService sastService;
    @Resource
    ThreadPoolTaskExecutor workerExecutor;
    @Resource
    RedisTemplateUtils redisTemplateUtils;
    @Test
    public void properties(){
        System.out.println(JSON.toJSONString(sastProperties));
    }
    @Test
    public void getToken(){
        String token = sastService.getToken();
        System.out.println(token);
    }
    @Test
    public void getTokenThread(){

        CyclicBarrier cyclicBarrier = new CyclicBarrier(2);
        String token1 = "";
        String token2 = "";
        redisTemplateUtils.del("REDIS_SAST_TOKEN_KEY");
        workerExecutor.submit(()->{
            try {
                cyclicBarrier.await();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            } catch (BrokenBarrierException e) {
                throw new RuntimeException(e);
            }
            log.info(sastService.getToken());
        });
        workerExecutor.submit(()->{
            try {
                cyclicBarrier.await();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            } catch (BrokenBarrierException e) {
                throw new RuntimeException(e);
            }
            log.info(sastService.getToken());
        });
    }

}
